public class Kaffeemaschine {
    private int anzahlPortionen = 0;
    
    public synchronized boolean holen() {
        if (anzahlPortionen>0) {
            System.out.println(Thread.currentThread().getName()+" holt Kaffee");
            anzahlPortionen--;
            return true;
        }
        System.out.println(Thread.currentThread().getName()+" Kein Kaffee");
        return false;
    }
    
    public synchronized void kochen() {
        if (anzahlPortionen<=0) {
            try{
                Thread.sleep(2000); // Kaffeekochen dauert
            } catch( InterruptedException e ) {}
            System.out.println(Thread.currentThread().getName()+" Kaffee gekocht");
            anzahlPortionen=10;
        }
    }
}
